## com.google.common.collect
Class ArrayListMultimap<K,V>

    java.lang.Object
      com.google.common.collect.ArrayListMultimap<K,V>

All Implemented Interfaces:
  ListMultimap<K,V>, Multimap<K,V>, Serializable

    @GwtCompatible(serializable=true,
                   emulated=true)
    public final class ArrayListMultimap<K,V>

extends Object

Implementation of `Multimap` that uses an `ArrayList` to store the values for a given key. A `HashMap` associates each key with an `ArrayList` of values.

When iterating through the collections supplied by this class, the ordering of values for a given key agrees with the order in which the values were added.

This multimap allows duplicate key-value pairs. After adding a new key-value pair equal to an existing key-value pair, the `ArrayListMultimap` will contain entries for both the new value and the old value.

Keys and values may be null. All optional multimap methods are supported, and all returned views are modifiable.

The lists returned by `get(K)`, `removeAll(java.lang.Object)`, and `replaceValues(K, java.lang.Iterable<? extends V>)` all implement `RandomAccess`.

This class is not threadsafe when any concurrent operations update the multimap. Concurrent read operations will work correctly. To allow concurrent update operations, wrap your multimap with a call to `Multimaps.synchronizedListMultimap(com.google.common.collect.ListMultimap<K, V>)`.

See the Guava User Guide article on `Multimap`.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Jared Levy
See Also:
  Serialized Form

Method Summary
`Map<K,Collection<V>>` `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
`void` `clear()` Removes all key-value pairs from the multimap.
`boolean` `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.

`static

`<K,V> ArrayListMultimap<K,V>`

`

`create()`
Creates a new, empty `ArrayListMultimap` with the default initial capacities.

`static

`<K,V> ArrayListMultimap<K,V>`

`

`create(int expectedKeys, int expectedValuesPerKey)`
Constructs an empty `ArrayListMultimap` with enough capacity to hold the specified numbers of keys and values without resizing.

`static

`<K,V> ArrayListMultimap<K,V>`

`

`create(Multimap<? extends K,? extends V> multimap)`
Constructs an `ArrayListMultimap` with the same mappings as the specified multimap.

`Collection<Map.Entry<K,V>>` `entries()` Returns a collection of all key-value pairs.
`boolean` `equals(Object object)` Compares the specified object to this multimap for equality.
`List<V>` `get(K key)` Returns a collection view of all values associated with a key.
`int` `hashCode()` Returns the hash code for this multimap.
`boolean` `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`Multiset<K>` `keys()` Returns a collection, which may contain duplicates, of all keys.
`Set<K>` `keySet()` Returns the set of all keys, each appearing once in the returned set.
`boolean` `put(K key, V value)` Stores a key-value pair in the multimap.
`boolean` `putAll(K key, Iterable<? extends V> values)` Stores a collection of values with the same key.
`boolean` `putAll(Multimap<? extends K,? extends V> multimap)` Copies all of another multimap's key-value pairs into this multimap.
`boolean` `remove(Object key, Object value)` Removes a single key-value pair from the multimap.
`List<V>` `removeAll(Object key)` Removes all values associated with a given key.
`List<V>` `replaceValues(K key, Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
`int` `size()` Returns the number of key-value pairs in the multimap.
`String` `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
`void` `trimToSize()` Reduces the memory used by this `ArrayListMultimap`, if feasible.
`Collection<V>` `values()` Returns a collection of all values in the multimap.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Multimap
`clear, containsEntry, containsKey, containsValue, entries, hashCode, isEmpty, keys, keySet, putAll, putAll, remove, size, values`

Method Detail

### create

    public static <K,V> ArrayListMultimap<K,V> create()

  Creates a new, empty `ArrayListMultimap` with the default initial capacities.

### create

    public static <K,V> ArrayListMultimap<K,V> create(int expectedKeys,
                                                      int expectedValuesPerKey)

  Constructs an empty `ArrayListMultimap` with enough capacity to hold the specified numbers of keys and values without resizing.

  Parameters:
    `expectedKeys` - the expected number of distinct keys
    `expectedValuesPerKey` - the expected average number of values per key
  Throws:
    `IllegalArgumentException` - if `expectedKeys` or `expectedValuesPerKey` is negative

### create

    public static <K,V> ArrayListMultimap<K,V> create(Multimap<? extends K,? extends V> multimap)

  Constructs an `ArrayListMultimap` with the same mappings as the specified multimap.

  Parameters:
    `multimap` - the multimap whose contents are copied to this multimap

### trimToSize

    public void trimToSize()

  Reduces the memory used by this `ArrayListMultimap`, if feasible.

### get

    public List<V> get(@Nullable
                       K key)

  Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

  Changes to the returned collection will update the underlying multimap, and vice versa.

  The returned collection is not serializable.

  Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

  Specified by:
    `get` in interface `ListMultimap<K,V>`
  Specified by:
    `get` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### removeAll

    public List<V> removeAll(@Nullable
                             Object key)

  Removes all values associated with a given key.

  The returned collection is immutable.

  Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

  Specified by:
    `removeAll` in interface `ListMultimap<K,V>`
  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.

### replaceValues

    public List<V> replaceValues(@Nullable
                                 K key,
                                 Iterable<? extends V> values)

  Stores a collection of values with the same key, replacing any existing values for that key.

  The returned collection is immutable.

  Because the values for a given key may have duplicates and follow the insertion ordering, this method returns a `List`, instead of the `Collection` specified in the `Multimap` interface.

  Specified by:
    `replaceValues` in interface `ListMultimap<K,V>`
  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

### put

    public boolean put(@Nullable
                       K key,
                       @Nullable
                       V value)

  Stores a key-value pair in the multimap.

  Specified by:
    `put` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` always

### asMap

    public Map<K,Collection<V>> asMap()

  Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue()` on its entries, `put`, or `putAll`.

  When passed a key that is present in the map, `asMap().get(Object)` has the same behavior as `Multimap.get(K)`, returning a live collection. When passed a key that is not present, however, `asMap().get(Object)` returns `null` instead of an empty collection.

  Though the method signature doesn't say so explicitly, the returned map has `List` values.

  Specified by:
    `asMap` in interface `ListMultimap<K,V>`
  Specified by:
    `asMap` in interface `Multimap<K,V>`
  Returns:
    a map view from a key to its collection of values

### equals

    public boolean equals(@Nullable
                          Object object)

  Compares the specified object to this multimap for equality.

  Two `ListMultimap` instances are equal if, for each key, they contain the same values in the same order. If the value orderings disagree, the multimaps will not be considered equal.

  Specified by:
    `equals` in interface `ListMultimap<K,V>`
  Specified by:
    `equals` in interface `Multimap<K,V>`

### size

    public int size()

  Description copied from interface: `Multimap`
  Returns the number of key-value pairs in the multimap.

  Specified by:
    `size` in interface `Multimap<K,V>`

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains no key-value pairs.

  Specified by:
    `isEmpty` in interface `Multimap<K,V>`

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains any values for the specified key.

  Specified by:
    `containsKey` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified value for any key.

  Specified by:
    `containsValue` in interface `Multimap<K,V>`
  Parameters:
    `value` - value to search for in multimap

### containsEntry

    public boolean containsEntry(@Nullable
                                 Object key,
                                 @Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified key-value pair.

  Specified by:
    `containsEntry` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### remove

    public boolean remove(@Nullable
                          Object key,
                          @Nullable
                          Object value)

  Description copied from interface: `Multimap`
  Removes a single key-value pair from the multimap.

  Specified by:
    `remove` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(@Nullable
                          K key,
                          Iterable<? extends V> values)

  Description copied from interface: `Multimap`
  Stores a collection of values with the same key.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(Multimap<? extends K,? extends V> multimap)

  Description copied from interface: `Multimap`
  Copies all of another multimap's key-value pairs into this multimap. The order in which the mappings are added is determined by `multimap.entries()`.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed

### clear

    public void clear()

  Description copied from interface: `Multimap`
  Removes all key-value pairs from the multimap.

  Specified by:
    `clear` in interface `Multimap<K,V>`

### keySet

    public Set<K> keySet()

  Description copied from interface: `Multimap`
  Returns the set of all keys, each appearing once in the returned set. Changes to the returned set will update the underlying multimap, and vice versa.

  Specified by:
    `keySet` in interface `Multimap<K,V>`
  Returns:
    the collection of distinct keys

### keys

    public Multiset<K> keys()

  Description copied from interface: `Multimap`
  Returns a collection, which may contain duplicates, of all keys. The number of times of key appears in the returned multiset equals the number of mappings the key has in the multimap. Changes to the returned multiset will update the underlying multimap, and vice versa.

  Specified by:
    `keys` in interface `Multimap<K,V>`
  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### values

    public Collection<V> values()

  Returns a collection of all values in the multimap. Changes to the returned collection will update the underlying multimap, and vice versa.

  The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on.

  Specified by:
    `values` in interface `Multimap<K,V>`
  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

### entries

    public Collection<Map.Entry<K,V>> entries()

  Returns a collection of all key-value pairs. Changes to the returned collection will update the underlying multimap, and vice versa. The entries collection does not support the `add` or `addAll` operations.

  The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on.

  Each entry is an immutable snapshot of a key-value mapping in the multimap, taken at the time the entry is returned by a method call to the collection or its iterator.

  Specified by:
    `entries` in interface `Multimap<K,V>`
  Returns:
    collection of map entries consisting of key-value pairs

### hashCode

    public int hashCode()

  Returns the hash code for this multimap.

  The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

  Specified by:
    `hashCode` in interface `Multimap<K,V>`
  Overrides:
    `hashCode` in class `Object`
  See Also:
    `Map.hashCode()`

### toString

    public String toString()

  Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the multimap

Copyright © 2010-2012. All Rights Reserved.